' ClipName.VBS V1.06 (C) yoshioka.teruo@nifty.com 2006-07-11
' ClipName.VBS sends path names of dropped files or arguments to clipboard.
' Usage: Start ClipName.VBS args...

Option Explicit
Const OLECMDID_COPY=12
Const OLECMDID_PASTE=13
Const OLECMDID_SELECTALL=17 '(&H11)
Const OLECMDEXECOPT_DODEFAULT=0
Dim ie
Dim ShiftKeys
Const shiftKey=1
Const ctrlKey=2
Const altKey=4
Const shiftLeft=8
Const ctrlLeft=16
Const altLeft=32

Set ie=CreateObject("InternetExplorer.Application")
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.body.onunload=GetRef("OnUnload") 
ie.Refresh
Do While IsEmpty(ShiftKeys)
  WScript.Sleep 100
Loop
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.body.onunload=Null
ie.Document.body.innerHTML="<textarea id=txt></textarea>"

Dim Shell
Dim fso
Dim k
Dim arg
Dim args
Dim text

Set Shell=CreateObject("Shell.Application")
Set fso=CreateObject("Scripting.FileSystemObject")

ReDim args(WScript.Arguments.Count)
For k=0 To WScript.Arguments.Count-1
  arg=WScript.Arguments.Item(k)
  If ShiftKeys And ctrlKey Then
    args(k)=fso.GetFile(arg).ShortPath
  ElseIf ShiftKeys And shiftKey Then
    arg=fso.GetAbsolutePathName(arg)
    arg=Shell.NameSpace(fso.GetParentFolderName(arg)).ParseName(fso.GetFileName(arg)).Path
    args(k)=""""&fso.GetFile(arg).Path&""""
  Else
    args(k)=arg
  End If
Next
args(k)=""
If ShiftKeys And altKey Then
  ie.Document.all.txt.focus
  Call ie.ExecWB(OLECMDID_PASTE,OLECMDEXECOPT_DODEFAULT)
  text=ie.Document.all.txt.value
  Select Case Right(text,1)
  Case vbLf,""
    args=text&Join(args,vbCrLf)
  Case Else
    args=text&vbCrLf&Join(args,vbCrLf)
  End Select
Else
  args=Join(args,vbCrLf)
End If

ie.Document.all.txt.value=args
ie.Document.all.txt.focus
ie.ExecWB OLECMDID_SELECTALL,OLECMDEXECOPT_DODEFAULT
ie.ExecWB OLECMDID_COPY,OLECMDEXECOPT_DODEFAULT
ie.Document.all.txt.value=""
ie.Document.all.txt.focus
Call ie.ExecWB(OLECMDID_PASTE,OLECMDEXECOPT_DODEFAULT)
If ShiftKeys Then
  MsgBox ie.Document.all.txt.value,vbSystemModal,WScript.ScriptName
Else
  WScript.Echo ie.Document.all.txt.value
End If
ie.Quit 
WScript.Quit

Sub OnUnload()
ShiftKeys=-Me.event.shiftLeft*shiftLeft-Me.event.shiftKey*shiftKey _
          -Me.event.altLeft*altLeft-Me.event.altKey*altKey _
          -Me.event.ctrlLeft*ctrlLeft-Me.event.ctrlKey*ctrlKey
End Sub
